diff --git a/web/regression/javascript/browser/preferences_spec.js b/web/regression/javascript/browser/preferences_spec.js
new file mode 100644
index 00000000..956b2c36
--- /dev/null
+++ b/web/regression/javascript/browser/preferences_spec.js
@@ -0,0 +1,140 @@
+import {pgBrowser} from 'pgadmin.browser.preferences';
+import $ from 'jquery';
+
+var dummy_cache = [
+  {
+    id: 1,
+    mid: 1,
+    module:'module1',
+    name:'pref1',
+    value:{
+      alt: false,
+      shift: false,
+      control: false,
+      key: {
+        char: 'a',
+        key_code: 65,
+      },
+    },
+  },{
+    id: 2,
+    mid: 1,
+    module:'module1',
+    name:'pref2',
+    value: 123,
+  },{
+    id: 3,
+    mid: 2,
+    module:'module2',
+    name:'pref2',
+    value: true,
+  },
+];
+
+describe('preferences related functions test', function() {
+  describe('get preference data related functions', function(){
+    beforeEach(function(){
+      pgBrowser.preferences_cache = dummy_cache;
+    });
+
+    it('get_preference', function(){
+      expect(pgBrowser.get_preference('module1','pref1')).toEqual({
+        id: 1,
+        mid: 1,
+        module:'module1',
+        name:'pref1',
+        value:{
+          alt: false,
+          shift: false,
+          control: false,
+          key: {
+            char: 'a',
+            key_code: 65,
+          },
+        },
+      });
+    });
+
+    it('get_preferences_for_module', function() {
+      expect(pgBrowser.get_preferences_for_module('module1')).toEqual({
+        'pref1':{
+          alt: false,
+          shift: false,
+          control: false,
+          key: {
+            char: 'a',
+            key_code: 65,
+          },
+        },
+        'pref2': 123,
+      });
+    });
+
+    it('get_preference_for_id', function() {
+      expect(pgBrowser.get_preference_for_id(3)).toEqual({
+        id: 3,
+        mid: 2,
+        module:'module2',
+        name:'pref2',
+        value: true,
+      });
+    });
+
+    it('reflectPreferences', function() {
+
+      let editorOptions = {
+        'tabSize':2,
+        'lineWrapping':false,
+        'autoCloseBrackets':true,
+        'matchBrackets':true,
+      };
+      pgBrowser.preferences_cache.push({
+        id: 4, mid: 3, module:'sqleditor', name:'sql_font_size', value: 1.456,
+      });
+      pgBrowser.preferences_cache.push({
+        id: 4, mid: 3, module:'sqleditor', name:'tab_size', value: editorOptions.tabSize,
+      });
+      pgBrowser.preferences_cache.push({
+        id: 4, mid: 3, module:'sqleditor', name:'wrap_code', value: editorOptions.lineWrapping,
+      });
+      pgBrowser.preferences_cache.push({
+        id: 4, mid: 3, module:'sqleditor', name:'insert_pair_brackets', value: editorOptions.autoCloseBrackets,
+      });
+      pgBrowser.preferences_cache.push({
+        id: 4, mid: 3, module:'sqleditor', name:'brace_matching', value: editorOptions.matchBrackets,
+      });
+
+      /* Spies */
+      pgBrowser.editor = jasmine.createSpyObj(
+        'CodeMirror', ['setOption','refresh','getWrapperElement']
+      );
+      spyOn($.fn, 'css');
+
+      /* Call */
+      pgBrowser.reflectPreferences();
+
+      /* Tests */
+      expect(pgBrowser.editor.getWrapperElement).toHaveBeenCalled();
+      expect($.fn.css).toHaveBeenCalledWith('font-size', '1.46em');
+
+      let setOptionCalls = pgBrowser.editor.setOption.calls;
+      expect(setOptionCalls.count()).toBe(Object.keys(editorOptions).length);
+
+      for(let i = 0; i < Object.keys(editorOptions).length; i++) {
+        let option = Object.keys(editorOptions)[i];
+        expect(setOptionCalls.argsFor(i)).toEqual([option, editorOptions[option]]);
+      }
+      expect(pgBrowser.editor.refresh).toHaveBeenCalled();
+    });
+
+    it('onPreferencesChange', function() {
+
+      window.parent.$ = $;
+      spyOn($.fn, 'on');
+
+      var eventHandler = jasmine.createSpy('eventHandler');
+      pgBrowser.onPreferencesChange('somemodule', eventHandler);
+      expect($.fn.on.calls.mostRecent().args[0]).toEqual('prefchange:somemodule');
+    });
+  });
+});
diff --git a/web/regression/javascript/history/query_history_spec.jsx b/web/regression/javascript/history/query_history_spec.jsx
index c49b19f0..b90d2a30 100644
--- a/web/regression/javascript/history/query_history_spec.jsx
+++ b/web/regression/javascript/history/query_history_spec.jsx
@@ -29,7 +29,7 @@ import '../helper/enzyme.helper';
 describe('QueryHistory', () => {
   let historyCollection;
   let historyWrapper;
-
+  let sqlEditorPref = {sql_font_size: '1em'};
   beforeEach(() => {
     jasmineEnzyme();
   });
@@ -37,7 +37,9 @@ describe('QueryHistory', () => {
   describe('when there is no history', () => {
     beforeEach(() => {
       historyCollection = new HistoryCollection([]);
-      historyWrapper = mount(<QueryHistory historyCollection={historyCollection}/>);
+      historyWrapper = mount(<QueryHistory historyCollection={historyCollection}
+        sqlEditorPref={sqlEditorPref}
+      />);
     });
 
     describe('when we switch to the query history tab', () => {
@@ -89,8 +91,9 @@ describe('QueryHistory', () => {
           message: 'something important ERROR:  message from second sql query',
         }];
         historyCollection = new HistoryCollection(historyObjects);
-
-        historyWrapper = mount(<QueryHistory historyCollection={historyCollection}/>);
+        historyWrapper = mount(<QueryHistory historyCollection={historyCollection}
+            sqlEditorPref={sqlEditorPref}
+        />);
 
         queryHistoryEntriesComponent = historyWrapper.find(QueryHistoryEntries);
         isInvisibleSpy = spyOn(queryHistoryEntriesComponent.instance(), 'isInvisible')
@@ -479,7 +482,9 @@ describe('QueryHistory', () => {
         }];
         historyCollection = new HistoryCollection(historyObjects);
 
-        historyWrapper = mount(<QueryHistory historyCollection={historyCollection}/>);
+        historyWrapper = mount(<QueryHistory historyCollection={historyCollection}
+            sqlEditorPref={sqlEditorPref}
+        />);
 
         const queryHistoryEntriesComponent = historyWrapper.find(QueryHistoryEntries);
         isInvisibleSpy = spyOn(queryHistoryEntriesComponent.instance(), 'isInvisible')
diff --git a/web/regression/javascript/sqleditor/keyboard_shortcuts_spec.js b/web/regression/javascript/sqleditor/keyboard_shortcuts_spec.js
index 06586d34..0e774814 100644
--- a/web/regression/javascript/sqleditor/keyboard_shortcuts_spec.js
+++ b/web/regression/javascript/sqleditor/keyboard_shortcuts_spec.js
@@ -9,6 +9,7 @@
 
 import keyboardShortcuts from 'sources/keyboard_shortcuts';
 import {queryToolActions} from 'sources/sqleditor/query_tool_actions';
+import gettext from 'sources/gettext';
 
 describe('the keyboard shortcuts', () => {
   const F1_KEY = 112,
@@ -18,7 +19,7 @@ describe('the keyboard shortcuts', () => {
     PERIOD_KEY = 190,
     FWD_SLASH_KEY = 191;
 
-  let sqlEditorControllerSpy, event, queryToolActionsSpy, queryToolkeyboardShortcutsConfig;
+  let sqlEditorControllerSpy, event, queryToolActionsSpy;
   beforeEach(() => {
     event = {
       shift: false,
@@ -29,8 +30,22 @@ describe('the keyboard shortcuts', () => {
       stopImmediatePropagation: jasmine.createSpy('stopImmediatePropagation'),
     };
 
-    queryToolkeyboardShortcutsConfig = {
-      execute: {
+    let gridView = {
+      query_tool_obj: {
+        getSelection: jasmine.createSpy('getSelection'),
+        getValue: jasmine.createSpy('getValue'),
+      },
+    };
+
+    sqlEditorControllerSpy = jasmine.createSpyObj('SqlEditorController', [
+      'isQueryRunning',
+      'execute',
+    ]);
+
+    sqlEditorControllerSpy.gridView = gridView;
+
+    sqlEditorControllerSpy.preferences = {
+      execute_query: {
         alt: false,
         shift: false,
         control: false,
@@ -38,7 +53,7 @@ describe('the keyboard shortcuts', () => {
           key_code: F5_KEY,
         },
       },
-      explain: {
+      explain_query: {
         alt: false,
         shift: false,
         control: false,
@@ -46,7 +61,7 @@ describe('the keyboard shortcuts', () => {
           key_code: F7_KEY,
         },
       },
-      explain_analyze: {
+      explain_analyze_query: {
         alt: false,
         shift: true,
         control: false,
@@ -80,20 +95,6 @@ describe('the keyboard shortcuts', () => {
       },
     };
 
-    let gridView = {
-      query_tool_obj: {
-        getSelection: jasmine.createSpy('getSelection'),
-        getValue: jasmine.createSpy('getValue'),
-      },
-    };
-
-    sqlEditorControllerSpy = jasmine.createSpyObj('SqlEditorController', [
-      'isQueryRunning',
-      'execute',
-    ]);
-
-    sqlEditorControllerSpy.gridView = gridView;
-
     queryToolActionsSpy = jasmine.createSpyObj(queryToolActions, [
       'explainAnalyze',
       'explain',
@@ -110,8 +111,7 @@ describe('the keyboard shortcuts', () => {
     beforeEach(() => {
       event.which = F1_KEY;
       keyboardShortcuts.processEventQueryTool(
-        sqlEditorControllerSpy, queryToolkeyboardShortcutsConfig,
-        queryToolActionsSpy, event
+        sqlEditorControllerSpy, queryToolActionsSpy, event
       );
     });
 
@@ -128,8 +128,7 @@ describe('the keyboard shortcuts', () => {
         event.shiftKey = false;
         event.ctrlKey = false;
         keyboardShortcuts.processEventQueryTool(
-          sqlEditorControllerSpy, queryToolkeyboardShortcutsConfig,
-          queryToolActionsSpy, event
+          sqlEditorControllerSpy, queryToolActionsSpy, event
         );
       });
 
@@ -151,8 +150,7 @@ describe('the keyboard shortcuts', () => {
         sqlEditorControllerSpy.isQueryRunning.and.returnValue(true);
 
         keyboardShortcuts.processEventQueryTool(
-          sqlEditorControllerSpy, queryToolkeyboardShortcutsConfig,
-          queryToolActionsSpy, event
+          sqlEditorControllerSpy, queryToolActionsSpy, event
         );
 
         expect(queryToolActionsSpy.executeQuery).not.toHaveBeenCalled();
@@ -168,8 +166,7 @@ describe('the keyboard shortcuts', () => {
         event.shiftKey = false;
         event.ctrlKey = false;
         keyboardShortcuts.processEventQueryTool(
-          sqlEditorControllerSpy, queryToolkeyboardShortcutsConfig,
-          queryToolActionsSpy, event
+          sqlEditorControllerSpy, queryToolActionsSpy, event
         );
       });
 
@@ -189,8 +186,7 @@ describe('the keyboard shortcuts', () => {
         sqlEditorControllerSpy.isQueryRunning.and.returnValue(true);
 
         keyboardShortcuts.processEventQueryTool(
-          sqlEditorControllerSpy, queryToolkeyboardShortcutsConfig,
-          queryToolActionsSpy, event
+          sqlEditorControllerSpy, queryToolActionsSpy, event
         );
 
         expect(queryToolActionsSpy.explain).not.toHaveBeenCalled();
@@ -206,8 +202,7 @@ describe('the keyboard shortcuts', () => {
         event.altKey = false;
         event.ctrlKey = false;
         keyboardShortcuts.processEventQueryTool(
-          sqlEditorControllerSpy, queryToolkeyboardShortcutsConfig,
-          queryToolActionsSpy, event
+          sqlEditorControllerSpy, queryToolActionsSpy, event
         );
       });
 
@@ -228,8 +223,7 @@ describe('the keyboard shortcuts', () => {
         sqlEditorControllerSpy.isQueryRunning.and.returnValue(true);
 
         keyboardShortcuts.processEventQueryTool(
-          sqlEditorControllerSpy, queryToolkeyboardShortcutsConfig,
-          queryToolActionsSpy, event
+          sqlEditorControllerSpy, queryToolActionsSpy, event
         );
 
         expect(queryToolActionsSpy.explainAnalyze).not.toHaveBeenCalled();
@@ -246,8 +240,7 @@ describe('the keyboard shortcuts', () => {
         event.ctrlKey = false;
 
         keyboardShortcuts.processEventQueryTool(
-          sqlEditorControllerSpy, queryToolkeyboardShortcutsConfig,
-          queryToolActionsSpy, event
+          sqlEditorControllerSpy, queryToolActionsSpy, event
         );
       });
 
@@ -270,8 +263,7 @@ describe('the keyboard shortcuts', () => {
         sqlEditorControllerSpy.isQueryRunning.and.returnValue(true);
 
         keyboardShortcuts.processEventQueryTool(
-          sqlEditorControllerSpy, queryToolkeyboardShortcutsConfig,
-          queryToolActionsSpy, event
+          sqlEditorControllerSpy, queryToolActionsSpy, event
         );
 
         expect(queryToolActionsSpy.download).not.toHaveBeenCalled();
@@ -286,8 +278,7 @@ describe('the keyboard shortcuts', () => {
           macKeysSetup();
           event.which = FWD_SLASH_KEY;
           keyboardShortcuts.processEventQueryTool(
-            sqlEditorControllerSpy, queryToolkeyboardShortcutsConfig,
-            queryToolActionsSpy, event
+            sqlEditorControllerSpy, queryToolActionsSpy, event
           );
         });
 
@@ -303,8 +294,7 @@ describe('the keyboard shortcuts', () => {
           windowsKeysSetup();
           event.which = FWD_SLASH_KEY;
           keyboardShortcuts.processEventQueryTool(
-            sqlEditorControllerSpy, queryToolkeyboardShortcutsConfig,
-            queryToolActionsSpy, event
+            sqlEditorControllerSpy, queryToolActionsSpy, event
           );
         });
 
@@ -328,8 +318,7 @@ describe('the keyboard shortcuts', () => {
 
         it('does nothing', () => {
           keyboardShortcuts.processEventQueryTool(
-            sqlEditorControllerSpy, queryToolkeyboardShortcutsConfig,
-            queryToolActionsSpy, event
+            sqlEditorControllerSpy, queryToolActionsSpy, event
           );
 
           expect(queryToolActionsSpy.commentLineCode).not.toHaveBeenCalled();
@@ -344,8 +333,7 @@ describe('the keyboard shortcuts', () => {
 
         it('does nothing', () => {
           keyboardShortcuts.processEventQueryTool(
-            sqlEditorControllerSpy, queryToolkeyboardShortcutsConfig,
-            queryToolActionsSpy, event
+            sqlEditorControllerSpy, queryToolActionsSpy, event
           );
 
           expect(queryToolActionsSpy.commentLineCode).not.toHaveBeenCalled();
@@ -361,8 +349,7 @@ describe('the keyboard shortcuts', () => {
           macKeysSetup();
           event.which = PERIOD_KEY;
           keyboardShortcuts.processEventQueryTool(
-            sqlEditorControllerSpy, queryToolkeyboardShortcutsConfig,
-            queryToolActionsSpy, event
+            sqlEditorControllerSpy, queryToolActionsSpy, event
           );
         });
 
@@ -377,8 +364,7 @@ describe('the keyboard shortcuts', () => {
           windowsKeysSetup();
           event.which = PERIOD_KEY;
           keyboardShortcuts.processEventQueryTool(
-            sqlEditorControllerSpy, queryToolkeyboardShortcutsConfig,
-            queryToolActionsSpy, event
+            sqlEditorControllerSpy, queryToolActionsSpy, event
           );
         });
 
@@ -402,8 +388,7 @@ describe('the keyboard shortcuts', () => {
 
         it('does nothing', () => {
           keyboardShortcuts.processEventQueryTool(
-            sqlEditorControllerSpy, queryToolkeyboardShortcutsConfig,
-            queryToolActionsSpy, event
+            sqlEditorControllerSpy, queryToolActionsSpy, event
           );
           expect(queryToolActionsSpy.uncommentLineCode).not.toHaveBeenCalled();
         });
@@ -416,8 +401,7 @@ describe('the keyboard shortcuts', () => {
 
         it('does nothing', () => {
           keyboardShortcuts.processEventQueryTool(
-            sqlEditorControllerSpy, queryToolkeyboardShortcutsConfig,
-            queryToolActionsSpy, event
+            sqlEditorControllerSpy, queryToolActionsSpy, event
           );
 
           expect(queryToolActionsSpy.uncommentLineCode).not.toHaveBeenCalled();
@@ -434,8 +418,7 @@ describe('the keyboard shortcuts', () => {
           event.which = FWD_SLASH_KEY;
           event.shiftKey = true;
           keyboardShortcuts.processEventQueryTool(
-            sqlEditorControllerSpy, queryToolkeyboardShortcutsConfig,
-            queryToolActionsSpy, event
+            sqlEditorControllerSpy, queryToolActionsSpy, event
           );
         });
 
@@ -454,8 +437,7 @@ describe('the keyboard shortcuts', () => {
           event.which = FWD_SLASH_KEY;
           event.shiftKey = true;
           keyboardShortcuts.processEventQueryTool(
-            sqlEditorControllerSpy, queryToolkeyboardShortcutsConfig,
-            queryToolActionsSpy, event
+            sqlEditorControllerSpy, queryToolActionsSpy, event
           );
         });
 
@@ -477,8 +459,7 @@ describe('the keyboard shortcuts', () => {
           event.which = FWD_SLASH_KEY;
           event.shiftKey = true;
           keyboardShortcuts.processEventQueryTool(
-            sqlEditorControllerSpy, queryToolkeyboardShortcutsConfig,
-            queryToolActionsSpy, event
+            sqlEditorControllerSpy, queryToolActionsSpy, event
           );
         });
         it('does nothing', () => {
@@ -491,8 +472,7 @@ describe('the keyboard shortcuts', () => {
           event.which = FWD_SLASH_KEY;
           event.shiftKey = true;
           keyboardShortcuts.processEventQueryTool(
-            sqlEditorControllerSpy, queryToolkeyboardShortcutsConfig,
-            queryToolActionsSpy, event
+            sqlEditorControllerSpy, queryToolActionsSpy, event
           );
         });
         it('does nothing', () => {
@@ -502,6 +482,45 @@ describe('the keyboard shortcuts', () => {
     });
   });
 
+  describe('shortcut to text converters', ()=> {
+    var shortcut = {
+      alt: false,
+      shift: false,
+      control: false,
+      key: {
+        char: 'a',
+        key_code: 65,
+      },
+    };
+
+    it('shortcut_key',()=>{
+      expect(keyboardShortcuts.shortcut_key(shortcut)).toBe('A');
+    });
+
+    it('shortcut_accesskey_title',()=>{
+      expect(keyboardShortcuts.shortcut_accesskey_title(
+        'Title', shortcut)).toBe(gettext('Title (accesskey + A)'));
+    });
+
+    it('shortcut_title',()=>{
+      shortcut.alt = true, shortcut.shift = false, shortcut.control = false;
+      expect(keyboardShortcuts.shortcut_title(
+        'Title', shortcut)).toBe(gettext('Title (Alt+A)'));
+
+      shortcut.alt = false, shortcut.shift = true, shortcut.control = false;
+      expect(keyboardShortcuts.shortcut_title(
+        'Title', shortcut)).toBe(gettext('Title (Shift+A)'));
+
+      shortcut.alt = false, shortcut.shift = false, shortcut.control = true;
+      expect(keyboardShortcuts.shortcut_title(
+        'Title', shortcut)).toBe(gettext('Title (Ctrl+A)'));
+
+      shortcut.alt = true, shortcut.shift = true, shortcut.control = true;
+      expect(keyboardShortcuts.shortcut_title(
+        'Title', shortcut)).toBe(gettext('Title (Alt+Shift+Ctrl+A)'));
+    });
+  });
+
   function expectEventPropagationToStop() {
     describe('stops all event propogation', () => {
 
diff --git a/web/regression/javascript/sqleditor_utils_spec.js b/web/regression/javascript/sqleditor_utils_spec.js
index c738f82a..75c34afc 100644
--- a/web/regression/javascript/sqleditor_utils_spec.js
+++ b/web/regression/javascript/sqleditor_utils_spec.js
@@ -28,5 +28,13 @@ function (SqlEditorUtils) {
         expect(SqlEditorUtils.capitalizeFirstLetter('create script')).toEqual('Create script');
       });
     });
+
+    describe('Calculate font size of input number passed', function () {
+      it('calcFontSize', function () {
+        expect(SqlEditorUtils.calcFontSize(1.456)).toEqual('1.46em');
+        expect(SqlEditorUtils.calcFontSize()).toEqual('0em');
+        expect(SqlEditorUtils.calcFontSize(2)).toEqual('2em');
+      });
+    });
   });
 });
diff --git a/web/webpack.shim.js b/web/webpack.shim.js
index c12e7f3b..41bf1033 100644
--- a/web/webpack.shim.js
+++ b/web/webpack.shim.js
@@ -124,6 +124,7 @@ var webpackShimConfig = {
     'bundled_codemirror': path.join(__dirname, './pgadmin/static/bundle/codemirror'),
     'bundled_browser': path.join(__dirname, './pgadmin/static/bundle/browser'),
     'sources': path.join(__dirname, './pgadmin/static/js'),
+    'sourcesjsx': path.join(__dirname, './pgadmin/static/jsx'),
     'pgadmin': path.join(__dirname, './pgadmin/static/js/pgadmin'),
     'translations': path.join(__dirname, './pgadmin/tools/templates/js/translations'),
     'sources/gettext': path.join(__dirname, './pgadmin/static/js/gettext'),
@@ -179,6 +180,7 @@ var webpackShimConfig = {
     'pgadmin.browser.error': path.join(__dirname, './pgadmin/browser/static/js/error'),
     'pgadmin.browser.frame': path.join(__dirname, './pgadmin/browser/static/js/frame'),
     'pgadmin.browser.keyboard': path.join(__dirname, './pgadmin/browser/static/js/keyboard'),
+    'pgadmin.browser.preferences': path.join(__dirname, './pgadmin/browser/static/js/preferences'),
     'pgadmin.browser.menu': path.join(__dirname, './pgadmin/browser/static/js/menu'),
     'pgadmin.browser.messages': '/browser/js/messages',
     'pgadmin.browser.node': path.join(__dirname, './pgadmin/browser/static/js/node'),
diff --git a/web/webpack.test.config.js b/web/webpack.test.config.js
index ef893e0b..757107ca 100644
--- a/web/webpack.test.config.js
+++ b/web/webpack.test.config.js
@@ -83,6 +83,7 @@ module.exports = {
       'pgadmin.backform': sourcesDir + '/js/backform.pgadmin',
       'pgbrowser': path.resolve(__dirname, 'regression/javascript/fake_browser'),
       'pgadmin.schema.dir': path.resolve(__dirname, 'pgadmin/browser/server_groups/servers/databases/schemas/static/js'),
+      'pgadmin.browser.preferences': path.join(__dirname, './pgadmin/browser/static/js/preferences'),
     },
   },
 };
